Description

Further to issues #444 and #1110, I think redmine needs its issue creation via email functionality to be improved.

I totally agree with Ewan Makepeace in #444 about FogBugz (http://www.fogcreek.com/FogBUGZ/). They have really done the

receiving email system right.

For those who aren't familiar with FogBugz, this is how it works:

Anyone can email your FogBugz email address, such as support@example.com

FogBugz implements a Spam filter to check incomming emails. (I don't think we need this.)

The email is turned into an Issue in the Inbox project.

The Issue is reviewed by staff and then moved into the appropriate project (if any, otherwise left in Inbox).

All email traffic between the business and clients is stored in FogBugz as an Issue, or follow-ups to an Issue.

The tracker type should be defaulted to Email. Emails that describe a feature/bug/etc can be updated by staff.

When an email conversation is finished, the staff resolve and close the Email Issue.

If the client later replies, the Issue is reopened automatically.

The major selling feature of FogBugz email integration is that the client does not need an account in your FogBugz to use the

system. This is achieved by using a special authentification token in the email response link:

Thank you for your message. We have received it and will get back to you as soon as possible.

We use FogBugz to keep track of our incoming email. You can check the status of your message at th

e following URL:

https://bitbot.fogbugz.com/default.asp?8_i2nobc50

You may want to save your case's tracking ticket: 8_i2nobc50

Please reply to this message if there's anything else we can do for you.

--

BitBot Software

bitbot at bitbot.com.au

---------------------------------------------------------------------------

Powered by FogBugz from Fog Creek Software. http://www.fogcreek.com/FogBugz

 At the bottom of the FogBugz Issue page, the client (who does not have a login) can see other issues submitted with their email

address. In this case, this email address submitted tickets 7 and 8.

The problem with Redmine is that an "Inbox" project allows all clients to read each other's emails. This is not good. FogBugz doesn't

have this problem. Only staff can view all clients emails.

In summary, I would like to publish an email address like support@example.com on my website. All email to that address is inserted

into Redmine as an Email Issue in the Inbox project, regardless of who it is from. The email is automatically responded to with a link

to the issue in Redmine, including an authentification token. This allows the client to see the issue in Redmine and their other issues,

but no-one elses. All this without a username/password.

Most clients won't need to follow the link either, since the system can be completely interacted with via email (from the client's point

of view).

I think most of this functionality already exists in Redmine, we just need to sort out the permissions system. Its pretty minor change
really, but does require a database field for the auth token.

Alternatively, perhaps it can be done by automatically creating a user account for the email address. But how do we stop them from

viewing emails from other clients?

Related issues:

Related to Redmine - Defect #3554: The IMAP method for anonymous issue creati... Reopened 2009-06-28

Related to Redmine - Defect #4407: Accept emails from anyone on a private pro... Closed 2009-12-15

Precedes Redmine - Feature #3003: Better handling of unknown and aliased emai... New 2009-03-18

Associated revisions

Revision 2789 - 2009-06-14 16:48 - Jean-Philippe Lang

Ability to accept incoming emails from unknown users (#2230, #3003).

An option lets you specify how to handle emails from unknown users:

ignore: the email is ignored (previous and default behaviour)

accept: the sender is considered as an anonymous user

create: a user account is created (username/password are sent back to the user)

Permissions have to be consistent with the chosen option. Eg. if you choose 'create', the 'Non member' role must have the 'Add issues' permission so

that an issue can be created by an unknown user via email. If you choose 'accept', the 'Anonymous' role must have this permission.

History

#1 - 2009-11-18 21:46 - Jean-Philippe Lang

- Target version set to 0.9.0

#2 - 2009-11-20 17:46 - Kolja K.

If you plan to put this issue in 0.9, it would be a really good idea to allow anonymous tickets with an email adress attached. This way, you are not

forced to have every email to create an user only to know who has created the ticket. Kind of light users only with an email adress and unable to log

in. Think of redirecting your webmaster@domain.com into redmine... and btw: there is a patch to activate a permission called "view own issues" -

perfect solution for inbox projects.

#3 - 2009-11-21 13:34 - Jean-Philippe Lang

- Target version deleted (0.9.0)

Yes, this would be a really good idea. But time is missing for adding this in 0.9.

#4 - 2009-11-22 14:16 - Mischa The Evil

- Target version set to 0.9.0

Jean-Philippe Lang wrote:

Target version deleted (0.9)

Yes, this would be a really good idea. But time is missing for adding this in 0.9.

 I've rebound this issue to version 0.9.0 since the ability to accept incoming emails from unknown users is actually implemented in r2789 which will be

included with/in 0.9.0. This way it also reaches the changelog of 0.9.0 when you close this issue.

I'll copy Kolja's message and your response to issue #3003 which I've also marked as an issue following this issue. From then issue #3003 can be

used for 0.9+ improvements of this feature.

#5 - 2009-11-24 03:46 - Brad Rushworth

Hey guys... thanks for doing this. You are both awesome! I haven't tried it yet but I had a read of your code.

I think its a useful feature that allows Redmine to be used outside of software development and for customer service roles as well. Similar functionality

is implemented in Jira and FogBugz (the two commercial products in this space). Having used both those products, I truly believe that Redmine is a

better product, and you can't beat the price!

ps I'm starting my software business full-time from January. Redmine is something I'm definitely using in-house but I'm also planning to install and

support it as a service to my clients. I've definitely seen an improvement to workflow and efficiency in many "knowledge worker" type industries by

having an integrated task-tracking system like Redmine.

I'm hoping to spend more time contributing ideas and code patches to Redmine too, so look out.
Thanks again.

#6 - 2009-12-19 15:08 - Jean-Philippe Lang

- Category changed from Email notifications to Email receiving

- Target version deleted (0.9.0)

As of r3195, you can allow anyone to submit emails to a private project.

But the token mechanism to access issues without any account will not be implemented in 0.9.

#7 - 2011-01-26 14:09 - O G

For what it's worth, the FogBugz-like flow that Brad described initially still sounds good to me.  From what I can tell from comments here, Redmine 

can accept email from anyone, and it can go to a private project, but I'm not sure if it works the same way as described in that flow.

Does anyone know if it does?  Thanks.
